#include "MPDF_UDF_FR.au3"
#include <Array.au3>
;------------- cration array -----------------------------------------
$entete = StringSplit("colonne 1,colonne 2,colonne 3,colonne 4,colonne 5,colonne 6,colonne 7", ",", 2)
Local $aArray[30][6]
For $i = 0 To UBound($aArray) - 1
	For $j = 0 To UBound($aArray, 2) - 1
		If $i = 0 Then
			$aArray[$i][$j] = $entete[$j]
		Else
			$nb =  Random(-100, 90000)
			$aArray[$i][$j] = $nb
		EndIf

	Next
Next
;----------- cration pdf -----------------------------------------------
	$sPDF = @ScriptDir & "\Example_Array2PDF.pdf"

	;set the properties for the pdf
	_SetTitle("Demo Array PDF in AutoIt")
	_SetSubject("Demo Array PDF in AutoIt, with formating")
	_SetKeywords("pdf, demo, table, AutoIt")
	_OpenAfter(True);open after generation
	_SetUnit($PDF_UNIT_CM)
	_SetPaperSize("A4")
	_SetZoomMode($PDF_ZOOM_FULLPAGE)
	_SetOrientation($PDF_ORIENTATION_PORTRAIT)
	_SetLayoutMode($PDF_LAYOUT_CONTINOUS)

	;initialize the pdf
	_InitPDF($sPDF)

	;=== load used font(s) ===
	_LoadFontTT("_CalibriI", $PDF_FONT_CALIBRI, $PDF_FONT_ITALIC)
	_LoadFontTT("_Calibri", $PDF_FONT_CALIBRI)

	;begin page
	_BeginPage()
	_DrawText( 1, 26, "Texte format, format nombre 2.3", "_CalibriI", 14)
	_ArrayToPdf($aArray, "_Calibri", 1, 11, 7, 14, 9,"","","","","",2.3);format chiffre 01,400
	_DrawText( 10.5, 26, "Texte non format, format nombre 4.2", "_CalibriI", 14)
	_ArrayToPdf($aArray, "_CalibriI", 10.5, 11, 10, 14, 10, "", "", "", "", "", 4.2, 0)
	_DrawText( 8.5, 20, "Array 1D", "_CalibriI", 14)
	_ArrayToPdf($entete, "_Calibri", 8.5, 16, 1.5, 3, 9, "" , "" , 0xFFFFFF);Array 1D
	$sTitle = "Exemple Array to PDF with AutoIt"
	_InsertRenderedText((_GetPageWidth() / _GetUnit()) / 2, _GetPageHeight() / _GetUnit() - 1.5, $sTitle, "_CalibriI", 32, 100, $PDF_ALIGN_CENTER, 0x996600, 0x441100)
	_EndPage()
	;write the buffer to disk
	_ClosePDFFile()


; #FUNCTION# ====================================================================================================================
; Name ..........: _ArrayToPdf
; Description ...: Import un array 1D ou 2D dans un PDF
; Syntax ........: _ArrayToPdf($aArray, $AliasFont, $iX, $iY[, $iW = 0[, $iH = 0[, $sizeFont = 10[, $lTxtColor = 0x000000[,
;                  $lBorderColor = 0x000000[, $LineHeader = 0x79F3FD[, $LineEven = 0xFFFFD5[, $LineOdd = 0xFFFFFF[,
;                  $FormatNumber[,$TextScaling = 1]]]]]]]]]])
; Parameters ....: $aArray              - An array of unknowns.La premire valeur est $aArray[0]
;                  $AliasFont           - valeur Alias Font par la cration des Fonts.
;                  $iX                  - coordonne X du coin infrieur gauche de l'array.
;                  $iY                  - coordonne Y du coin infrieur gauche de l'array.
;                  $iW                  - [optional] Largeur Array. Si 0 calcul par rapport  la page Default is 0.
;                  $iH                  - [optional] Hauteur Array. Si 0 calcul par rapport  $iW Default is 0.
;                  $sizeFont            - [optional] Taille Font. Default is 10.
;                  $lTxtColor           - [optional] Couleur texte. Default is 0x000000.(noir)
;                  $lBorderColor        - [optional] Couleur bordure. Default is 0x000000.(noir)
;                  $LineHeader          - [optional] Couleur entte. Default is 0x79F3FD.(bleu clair)
;                  $LineEven            - [optional] Couleur ligne pair. Default is 0xFFFFD5.(jaune clair)
;                  $LineOdd             - [optional] Couleur ligne impair. Default is 0xFFFFFF.(blanc)
;                  $FormatNumber        - [optional] Format nombre E.g. 4.3 (0231,120). Default is 0 (none)
;				   $TextScaling         - [optional] Mise  l'chelle des valeurs dans les cells = 1, autrement = 0. Default is 1.
; Return values .: None
; Author ........: taietel
; Modified ......: Walkson
; ===============================================================================================================================
Func _ArrayToPdf($aArray, $AliasFont, $iX, $iY, $iW = 0, $iH = 0, $sizeFont = 10, $lTxtColor = 0x000000, $lBorderColor = 0x000000, $LineHeader = 0x79F3FD, $LineEven = 0xFFFFD5, $LineOdd = 0xFFFFFF, $FormatNumber = 0, $TextScaling = 1)
	If Not IsArray($aArray) Then Return SetError(1, 0, 1)
	$iRows = UBound($aArray)
	$iCols = UBound($aArray, 2)
	If $iCols = 0 Then ;si Array 1D
		$aArrayclone = $aArray
		ReDim $aArrayclone[$iRows][1]
		$iRows = UBound($aArrayclone)
		$iCols = UBound($aArrayclone, 2)
		For $i = 0 To $iRows - 1
			$aArrayclone[$i][0] = $aArray[$i]
		Next
		$aArray = $aArrayclone ;convertir en Array 2D
	EndIf
	If $sizeFont = "" Then $sizeFont = 10
	If $iW = "" Then $iW = 0 ;largeur automatique
	If $iH = "" Then $iH = 0 ;hauteur automatique
	If $lTxtColor = "" Then $lTxtColor = 0x000000 ;noir
	If $lBorderColor = "" Then $lBorderColor = 0x000000 ;noir
	If $LineHeader = "" Then $LineHeader = 0x79F3FD ;bleu clair
	If $LineEven = "" Then $LineEven = 0xFFFFD5 ;jaune clair
	If $LineOdd = "" Then $LineOdd = 0xFFFFFF ;blanc
	If StringInStr($FormatNumber,".") <> 0 Then ;format nombres
		$fFormat = StringSplit($FormatNumber,".")
		If $fFormat[0] > 2 Then Return SetError(1,0,1)
		Local $iDecimal = $fFormat[2]
		Local $inbNumber = $fFormat[1] + $fFormat[2] + 1
	EndIf

	Local $iPgW = Round(_GetPageWidth() / _GetUnit(), 1)
	Local $iPgH = Round(_GetPageHeight() / _GetUnit(), 1)
	If $iW = 0 Then $iW = $iPgW - $iX - 2
	If $iH = 0 Then $iH = $iPgH - $iY - 2
	_SetColourStroke($lBorderColor)
	_Draw_Rectangle($iX, $iY, $iW, $iH, $PDF_STYLE_STROKED, 0, $lBorderColor, 0.1)
	_SetColourStroke(0)
	Local $iColW = $iW / $iCols
	Local $iRowH = $iH / $iRows
	Local $lRGB
	For $i = 0 To $iRows - 1
		For $j = 0 To $iCols - 1
			If $i = 0 Then
				$lRGB = $LineHeader ;  fond cell entete
			Else
				If Mod($i, 2) = 0 Then ;fond ligne pair ou impair
					$lRGB = $LineOdd
				Else
					$lRGB = $LineEven
				EndIf

			EndIf
			_SetColourStroke($lBorderColor)
			_Draw_Rectangle($iX + $j * $iColW, $iY + $iH - ($i + 1) * $iRowH, $iColW, $iRowH, $PDF_STYLE_STROKED, 0, $lRGB, 0.01)
			_SetColourStroke(0)
			Local $sText = $aArray[$i][$j]
			 If  $FormatNumber <> 0 And Number($sText) <> 0 And StringLeft($sText,1) = "-" Then $sText =  StringFormat("%0" & $inbNumber + 1 & ".0" & $iDecimal & "f", $sText)
			If  $FormatNumber <> 0 And Number($sText) <> 0 And StringLeft($sText,1) <> "-" Then $sText =  StringFormat("%0" & $inbNumber & ".0" & $iDecimal & "f", $sText)
			Local $sLength = Round(_GetTextLength($sText, $AliasFont, $sizeFont), 1)
			$lScale = Ceiling(0.75 * $iColW * 100 / $sLength)
			_SetColourFill($lTxtColor)
			If $TextScaling = 1 Then _SetTextHorizontalScaling($lScale);normalise largeur contenu
			_DrawText($iX + $j * $iColW + ($iColW * 9.5) / 10, $iY + $iH - ($i + 1) * $iRowH + ($iRowH - 10 / _GetUnit()) / 2, $sText, $AliasFont, $sizeFont, $PDF_ALIGN_RIGHT, 0)
			_SetTextHorizontalScaling(100)
			_SetColourFill(0)
		Next
	Next
EndFunc   ;==>_ArrayToPdf
