#include "..\MPDF_UDF_FR.au3"
;Importe une diapo dans PDF
;Modifier les chemins et les variables du programme Office
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
_LoadFontStandard("_Cour", $PDF_FONT_STD_COURIER)
$NSlide = 1
$FilePath = @ScriptDir & "\Prsentation1.pptx"
_LoadSlidePpt("azerty", $NSlide, $FilePath)

_BeginPage()
_InsertRenderedText(5, 28, ">> Diapo PowerPoint <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(1, 26, "Import diapo N " & $NSlide & " de " & $FilePath, "_Cour", 12, $PDF_ALIGN_LEFT)
_InsertImage("azerty", 2, 25, 15)
_EndPage()
_ClosePDFFile()

; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadSlidePpt
; Description ...: Import diapo PowerPoint dans PDF
; Syntax ........: _LoadSlidePpt($sImgAlias, $NSlide, $FilePath)
; Parameters ....: $sImgAlias           - A string value.
;                  $NSlide              - N diapo.
;                  $FilePath            - Chemin classeur PowerPoint.
; Return values .: None
; ===============================================================================================================================
Func _LoadSlidePpt($sImgAlias, $NSlide, $FilePath)
	If $sImgAlias = "" Then Exit MsgBox(0, "Error", "Absence d'Alias")
	If $NSlide = "" Then Exit MsgBox(0, "Error", "Manque N diapo")
	If Not FileExists($FilePath) Then Exit MsgBox(0, "Error", "Chemin PowerPoint invalide")
	$oPPT = ObjCreate("PowerPoint.Application")
	If @error Then Exit MsgBox(0, "Error", "No PowerPoint available")
	$oPPT.Visible = True
	$oPPTopen = $oPPT.Presentations.Open($FilePath, -1);lecture seule
	$oPPT.ActivePresentation.Application.WindowState = 2 ;windows mini
	If @error Then Exit MsgBox(0, "Error", "No PowerPoint available")
	$nbSlides = $oPPT.ActivePresentation.Slides.Count
	$FileImage = @ScriptDir & "\powerpoint" & @MSEC & ".jpg"
	If $NSlide < $nbSlides + 1 Then
		$oPPT.ActivePresentation.Slides($NSlide).Export($FileImage, "jpg")
		$oPPT.Quit
	Else
		$oPPT.Quit
		Exit MsgBox(0, "Error", "Nb slides invalid number")
	EndIf

	_GDIPlus_Startup()
	$hImage = _GDIPlus_BitmapCreateFromFile($FileImage)
	$iW = _GDIPlus_ImageGetWidth($hImage)
	$iH = _GDIPlus_ImageGetHeight($hImage)
	$ImgBuf = __ToBinary($FileImage)
	$_iImageW = $iW
	$_iImageH = $iH
	$iObj = __InitObj()
	__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
	__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
	__EndObj()
	$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
	__InitObj()
	__ToBuffer(StringLen($ImgBuf))
	__EndObj()
	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_Shutdown()
	If FileExists($FileImage) Then FileDelete($FileImage)
	Return $_Image
EndFunc   ;==>_LoadSlidePpt
