#include "..\MPDF_UDF_FR.au3"
;Import Vcard dans PDF
;Si OutLook fonctionne, ce script ne fermera pas la session
;office 2007 minimum
;Modifier les chemins et les variables du programme Office
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
VcardToPdf(1, "toto")

_BeginPage()
_InsertRenderedText(5, 28, ">> Vcard OutLook <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_InsertImage("toto", 2, 20)
_EndPage()
_ClosePDFFile()
; #FUNCTION# ====================================================================================================================
; Name...........: VcardToPdf
; Description ...: Import Vcard OutLook 2007 et + dans PDF
; Syntax.........: VcardToPdf($hItem,$HImage)
; Parameters ....: $hItem  - item de l'agenda ou le nom complet e.g. "Louis DUPONT"
;                  $sImgAlias - Alias
; Return values .: no
; Author ........:
; Modified ......:
; Remarks .......: OutLook Office 2007 version franaise doit tre install
; 					si OutLook est en fonction, l'enregistrement est trs rapide et inversement
; ===============================================================================================================================
Func VcardToPdf($hItem, $sImgAlias)
	If $hItem = "" Or $sImgAlias = "" Then Exit MsgBox(0,"Erreur","Fonction VcardToPdf incomplte")
	Local $oImage = @ScriptDir & "\Vcardimage" & @MSEC & ".jpg"
	Global Const $olFolderContacts = 10
	Global $oOutlook, $control = False
	If Not FileExists(@ProgramFilesDir & "\Microsoft Office\Office12\OUTLOOK.EXE") Then Exit MsgBox(0,"Erreur","Office12\OUTLOOK.EXE inexistant")
	If Not ProcessExists("OUTLOOK.EXE") Then
		Run(@ProgramFilesDir & "\Microsoft Office\Office12\OUTLOOK.EXE")

	Else
		$control = True ;garde OutLook fonctionnel  la fin du script
	EndIf

	$init = TimerInit()
	While 1
		Sleep(500)
		If ProcessExists("OUTLOOK.EXE") Then
			If $control = False Then WinSetState("Bote de rception - Microsoft Outlook", "", @SW_MINIMIZE)
			$oOutlook = ObjGet("", "Outlook.Application")
			If Not @error Then ExitLoop
		EndIf
		If TimerDiff($init) > 60000 Then
			ProcessClose("OUTLOOK.EXE")
			MsgBox(0, "Erreur", "L'attente est dpasse, lancez OutLook sparment du script")
			Exit
		EndIf

	WEnd

	Global $App = $oOutlook.Application
	$App.ActiveWindow.WindowState = 1
	Global $myNms = $App.GetNamespace("MAPI")
	Global $myfolder = $myNms.GetDefaultFolder($olFolderContacts) ;olFolderContacts = 10
	Global $myContactItem = $myfolder.Items($hItem)

	If Not IsObj($myContactItem) Then
		MsgBox(0, "Erreur", "Item ou nom complet introuvable")
		If $control = False Then
			If ProcessExists("OUTLOOK.EXE") Then ProcessClose("OUTLOOK.EXE")
		EndIf
		Exit
	EndIf

	$myContactItem.SaveBusinessCardImage($oImage) ;Version ajoute :  Outlook 2007
	If $control = False Then
		If ProcessExists("OUTLOOK.EXE") Then ProcessClose("OUTLOOK.EXE")
	EndIf
				_GDIPlus_Startup()
				$hImage = _GDIPlus_ImageLoadFromFile($oImage)
				$iW = _GDIPlus_ImageGetWidth($hImage)
				$iH = _GDIPlus_ImageGetHeight($hImage)
				$ImgBuf = __ToBinary($oImage)
				$_iImageW = $iW
				$_iImageH = $iH
				$iObj = __InitObj()
				__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
				__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
				__EndObj()
				$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
				__InitObj()
				__ToBuffer(StringLen($ImgBuf))
				__EndObj()
				_GDIPlus_ImageDispose($hImage)
				_GDIPlus_Shutdown()
				FileDelete($oImage)
	Return $_Image
EndFunc   ;==>VcardToImage
