#include "..\MPDF_UDF_FR.au3"
;Importe un tableau Word dans PDF
;Modifier les chemins et les variables du programme Office
; Seul, les formats fait "main" seront reproduits et non les formats automatique tel que le tableau 3
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt, Word")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
_LoadFontStandard("_Cour", $PDF_FONT_STD_COURIER)
_LoadPicTableWord("azerty",@ScriptDir & "\DOC.docx",2); 2 tableaux sur le Doc
_LoadPicTableWord("azerty1",@ScriptDir & "\DOC.docx",1)
_BeginPage()
_InsertRenderedText(5, 28, ">> Tableaux WORD <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(2, 5, "Questo  un Test: quanto si utilizza un carattere accentato.  ", "_Cour", 12, $PDF_ALIGN_LEFT)
_InsertImage("azerty1", 1, 27, 18)
_InsertImage("azerty", 1, 20, 15)
_InsertImage("azerty", 0, 5, 21, 6)
_EndPage()
_ClosePDFFile()

OnAutoItExitRegister ( "closeWord" );controle la fermeture de Word (si erreur)
; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadPicTableWord
; Description ...: Load a image in the pdf (if you use it multiple times it decreases the size of the pdf)
; Syntax ........: _LoadPicTableWord($sImgAlias,$sFilePath,$TableNb = 1 )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sFilePath              -  chemin dossier Word
;					$TableNb				- N du tableau (selon cration) 1 par dfaut
; Return values .: no
; Author(s) .....: Walkson
; Modified ......:
; Remarks .......:Pour les mots de passe modifiez la fonction  _Word_DocOpen2()
; Related .......: _LoadResBinary  _ClipboardToStringImage() _Word_DocOpen2
; Link ..........:
; Example .......: No
; =========================================================================================================
Func _LoadPicTableWord($sImgAlias,$sFilePath,$TableNb = 1 )
If Not FileExists($sFilePath) Then Return SetError(1,0,1)
If ProcessExists("WINWORD.exe") Then Sleep(1000)
If ProcessExists("WINWORD.exe") Then MsgBox(48,"MISE EN GARDE","Fermez toutes les applications WORD")
$oAppl = ObjCreate("Word.Application")
If @error Then Return SetError(1,0,1)
$oAppl.Visible = False;invisible
_Word_DocOpen2($oAppl, $sFilePath, Default,  Default, True);lecture seule
$nbT = $oAppl.ActiveDocument.Tables.Count
If $TableNb > $nbT Then  Return SetError(1,0,1)
 $oAppl.ActiveDocument.Tables($TableNb).Select
$oAppl.Selection.Copy;copi la table
$oAppl.Selection.EndKey(6)
$oAppl.Selection.Range.PasteSpecial(False,False,Default,False,9);converti en image
    $nb = $oAppl.ActiveDocument.Shapes.Count
    $oAppl.ActiveDocument.Shapes.Item($nb).Select
	$oAppl.Selection.Copy
$imageV = _ClipboardToStringImage();rcupre le clipboard
If $imageV = "" Then Return SetError(1,0,1)
$Image = Binary($imageV)
;$chemin = FileOpen(@ScriptDir & "\bitmap.bmp", 2 + 8);rcupre l'image "en dur"
;FileWrite($chemin,$sImage)
;FileClose($chemin)
 $oAppl.Quit(0);pas de sauvegarde
 _LoadResBinary($sImgAlias, $Image )
EndFunc
; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadResBinary
; Description ...: Load a image in the pdf from memory
; Syntax ........: _LoadResImage( $sImgAlias , $sImage  )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sImage              -  image From Memory.
; Return values .: Success      - True
;                  Failure      - False
; Author(s) .....: Mihai Iancu (taietel at yahoo dot com)
; Modified ......: Walkson
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/118827-create-pdf-from-your-application/
; Example .......: No
; =========================================================================================================
Func _LoadResBinary($sImgAlias, $sImage )
	Local $iW, $iH, $ImgBuf, $hImage, $hImageExt, $newImg, $hClone, $hGraphics, $iObj
	If $sImgAlias = "" Then __Error("You don't have an alias for the image", @ScriptLineNumber)
	If $sImage = ""  Then
		__Error("You don't have any images to insert or the path is invalid",@ScriptLineNumber)
	Else
				_GDIPlus_Startup()
				$hImage = _GDIPlus_BitmapCreateFromMemory($sImage)
				$bitmap = _Bitmap2BinaryString($hImage, 90);mise au format jpg
				$iW = _GDIPlus_ImageGetWidth($hImage)
				$iH = _GDIPlus_ImageGetHeight($hImage)
				_GDIPlus_ImageSaveToFile($hImage, $newImg)
				$ImgBuf = BinaryToString($bitmap);mise en mmoire du jpg
				$_iImageW = $iW
				$_iImageH = $iH
				$iObj = __InitObj()
				__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
				__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
				__EndObj()
				$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
				__InitObj()
				__ToBuffer(StringLen($ImgBuf))
				__EndObj()
				_GDIPlus_ImageDispose($hImage)
				_GDIPlus_Shutdown()

	EndIf
	Return $_Image
EndFunc   ;==>_LoadResImage

; #FUNCTION# ====================================================================================================================
; Author ........: water (based on the Word UDF written by Bob Anthony)
; Modified ......:
; ===============================================================================================================================
Func _Word_DocOpen2($oAppl, $sFile, $bConfirmConversions = Default, $iFormat = Default, $bReadOnly = Default, $bRevert = Default, $bAddToRecentFiles = Default, $sOpenPassword = Default, $sWritePassword = Default)
	If $bConfirmConversions = Default Then $bConfirmConversions = False
	If $iFormat = Default Then $iFormat = 0
	If $bReadOnly = Default Then $bReadOnly = False
	If $bRevert = Default Then $bRevert = False
	If $bAddToRecentFiles = Default Then $bAddToRecentFiles = False
	If $sOpenPassword = Default Then $sOpenPassword = ""
	If $sWritePassword = Default Then $sWritePassword = ""
	If Not IsObj($oAppl) Then Return SetError(1, 0, 0)
	If Not FileExists($sFile) Then Return SetError(2, 0, 0)
	If StringInStr($sFile, "\") = 0 Then $sFile = @ScriptDir & "\" & $sFile
	Local $oDoc = $oAppl.Documents.Open($sFile, $bConfirmConversions, $bReadOnly, $bAddToRecentFiles, _
			$sOpenPassword, "", $bRevert, $sWritePassword, "", $iFormat)
	If @error Or Not IsObj($oDoc) Then Return SetError(3, @error, 0)
	; If a read-write document was opened read-only then return an error
	If $bReadOnly = False And $oDoc.Readonly = True Then Return SetError(4, 0, $oDoc)
	Return $oDoc
EndFunc   ;==>_Word_DocOpen
Func closeWord()
	If ProcessExists("WINWORD.exe") Then ProcessClose("WINWORD.exe")
EndFunc












