#include "..\MPDF_UDF_FR.au3"
;Import un graphique Excel dans PDF
;Modifier les chemins et les variables du programme Office
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
_LoadFontStandard("_Cour", $PDF_FONT_STD_COURIER)
_LoadPicGraphExcel("azerty", @ScriptDir & "\Classeur1.xlsx", 1,"Graphique 1" )
_LoadPicGraphExcel("bazbaz", @ScriptDir & "\Classeur1.xlsx", 2,"Graphique A" )
_BeginPage()
_InsertRenderedText(5, 28, ">> Graphique EXCEL <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(2, 15, "Questo  un Test: quanto si utilizza un carattere accentato.  ", "_Cour", 12, $PDF_ALIGN_LEFT)
_InsertImage("azerty", 2, 25, 13)
_InsertImage("bazbaz", 2, 10, 13)
_EndPage()
_ClosePDFFile()


; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadPicGraphExcel
; Description ...: Load a image in the pdf from graph excel
; Syntax ........: _LoadPicGraphExcel($sImgAlias, $sFilePath,$SheetsNb,$NameGraph )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sFilePath              -  chemin du classeur excel.
;                  $SheetsNb              -  N sheets (par ordre de cration e.g. 2 )
;                  $NameGraph              -  Nom du graphique
; Return values .: no
; Author(s) .....: Walkson
; Modified ......:
; Remarks .......:
; Related .......: _LoadResBinary  _ClipboardToStringImage()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _LoadPicGraphExcel($sImgAlias, $sFilePath,$SheetsNb,$NameGraph )
If $sImgAlias = "" Then Exit MsgBox(48,"ERREUR","Absence alias")
If Not FileExists($sFilePath) Then Exit MsgBox(48,"ERREUR","Chemin Excel invalide")
If $SheetsNb = "" Or $NameGraph = "" Then Exit MsgBox(48,"ERREUR","Absence donnes Excel")
If ProcessExists("EXCEL.exe") Then Sleep(1000)
If ProcessExists("EXCEL.exe") Then MsgBox(48,"Important !!","Fermez toutes les applications Excel")
$oExcel = ObjCreate("Excel.Application")
If @error Then ErreurExcel()
$oExcel.Visible = False ; invisible
$oExcel.ScreenUpdating = True
$oExcel.DisplayAlerts = False
 _Excel_BookOpenA($oExcel, $sFilePath, True,  Default, Default,  Default);lecture seule
$NbS = $oExcel.Sheets.Count
If $SheetsNb > $NbS Then ErreurExcel();erreur nb feuil
$NbG = $oExcel.Sheets($SheetsNb).ChartObjects.Count
If $NbG = 0 Then ErreurExcel();erreur nb graph
For $i = 1 To $NbG
	If $NameGraph = $oExcel.Sheets($SheetsNb).ChartObjects.Item($i).Name Then
		$NameGraphTR = 1
		ExitLoop
	Else
		$NameGraphTR = 0
	EndIf
Next
If $NameGraphTR = 0 Then ErreurExcel();erreur nom du graph pas trouv
 $image = @ScriptDir & "\Graph" & @MSEC & ".jpg"
 $oExcel.Sheets($SheetsNb).ChartObjects($NameGraph).Chart.Export($image,"JPG")
$oExcel.Saved = True;pas de sauvegarde
 $oExcel.Quit()
 _LoadResBinary($sImgAlias, $image )
EndFunc
; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadResBinary
; Description ...: Load a image in the pdf (if you use it multiple times it decreases the size of the pdf)
; Syntax ........: _LoadResImage( $sImgAlias , $sImage  )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sImage              -  image .
; Return values .: Success      - True
;                  Failure      - False
; Author(s) .....: Mihai Iancu (taietel at yahoo dot com)
; Modified ......: Walkson
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/118827-create-pdf-from-your-application/
; Example .......: No
; ===============================================================================================================================
Func _LoadResBinary($sImgAlias, $sImage )
	Local $iW, $iH, $ImgBuf, $hImage, $hImageExt, $newImg, $hClone, $hGraphics, $iObj
	If $sImgAlias = "" Then __Error("You don't have an alias for the image", @ScriptLineNumber)
	If $sImage = ""  Then
		__Error("You don't have any images to insert or the path is invalid",@ScriptLineNumber)
	Else
				_GDIPlus_Startup()
				$hImage = _GDIPlus_BitmapCreateFromFile($sImage)
				$iW = _GDIPlus_ImageGetWidth($hImage)
				$iH = _GDIPlus_ImageGetHeight($hImage)
				$ImgBuf =  __ToBinary($sImage)
				$_iImageW = $iW
				$_iImageH = $iH
				$iObj = __InitObj()
				__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
				__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
				__EndObj()
				$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
				__InitObj()
				__ToBuffer(StringLen($ImgBuf))
				__EndObj()
				_GDIPlus_ImageDispose($hImage)
				_GDIPlus_Shutdown()
				If FileExists($sImage) Then FileDelete($sImage)

	EndIf
	Return $_Image
EndFunc   ;==>_LoadResImage
; Author ........: SEO <locodarwin at yahoo dot com>
; Modified.......: litlmike, water, GMK
Func _Excel_BookOpenA($oExcel, $sFilePath, $bReadOnly = Default, $bVisible = Default, $sPassword = Default, $sWritePassword = Default)
	If Not IsObj($oExcel) Or ObjName($oExcel, 1) <> "_Application" Then Return SetError(1, @error, 0)
	If Not FileExists($sFilePath) Then Return SetError(2, 0, 0)
	If $bReadOnly = Default Then $bReadOnly = False
	If $bVisible = Default Then $bVisible = True
	Local $oWorkbook = $oExcel.Workbooks.Open($sFilePath, Default, $bReadOnly, Default, $sPassword, $sWritePassword)
	If @error Then Return SetError(3, @error, 0)
	$oExcel.Windows($oWorkbook.Name).Visible = $bVisible
	; If a read-write workbook was opened read-only then return an error
	If $bReadOnly = False And $oWorkbook.Readonly = True Then Return SetError(4, 0, $oWorkbook)
	Return $oWorkbook
EndFunc   ;==>_Excel_BookOpen
Func ErreurExcel()
	If ProcessExists("EXCEL.exe") Then ProcessClose("EXCEL.exe")
	ConsoleWrite(">>>>>>>>> Erreur Excel >>>>>>>>> Arret" & @CR)
	Exit
EndFunc