#include "..\MPDF_UDF_FR.au3"
;Import table ou TCD Excel dans PDF
;Modifier les chemins et les variables du programme Office
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
_LoadFontStandard("_Cour", $PDF_FONT_STD_COURIER)
_LoadPicTableExcel("TABLE", @ScriptDir & "\Classeur1.xlsx", 1, "A1:C12")
_LoadPicPivotTablesExcel("TCD1", @ScriptDir & "\Classeur1.xlsx", 3, "TCD")

_BeginPage()
_InsertRenderedText(5, 28, ">> Tableaux EXCEL <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(2, 27, "Insertion d'une table et d'un tableau crois dynamique", "_Cour", 12, $PDF_ALIGN_LEFT)
_InsertImage("TABLE", 2, 19, 9, 7)
_InsertImage("TCD1", 2, 7, 12, 11)
_EndPage()
_ClosePDFFile()

; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadPicPivotTablesExcel
; Description ...: Import une image d'un tableau crois dynamique excel dans PDF
; Syntax ........: _LoadPicPivotTablesExcel($sImgAlias, $sFilePath,$SheetsNb,$PivotTable )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sFilePath           -  chemin du classeur excel.
;                  $SheetsNb            -  N sheets (par ordre de cration e.g. 2 )
;                  $PivotTable          -  Index ou nom de la table
; Return values .: no
; Author(s) .....: Walkson
; Modified ......:
; Remarks .......: Version ajoute :  Excel 2007
; Related .......: _LoadResBinary  _ClipboardToStringImage()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _LoadPicPivotTablesExcel($sImgAlias, $sFilePath, $SheetsNb, $PivotTable)
	If Not FileExists($sFilePath) Then Exit
	If ProcessExists("EXCEL.exe") Then Sleep(1000)
	If ProcessExists("EXCEL.exe") Then MsgBox(48, "MISE EN GARDE", "Fermez toutes les applications Excel")
	$oExcel = ObjCreate("Excel.Application")
	If @error Then ErreurExcel()
	$oExcel.Visible = False ; invisible
	$oExcel.ScreenUpdating = True
	$oExcel.DisplayAlerts = False
	_Excel_BookOpenA($oExcel, $sFilePath, True, Default, Default, Default);lecture seule
	$NbS = $oExcel.Sheets.Count
	ConsoleWrite("feuil " & $NbS & @CRLF)
	If $SheetsNb > $NbS Then ErreurExcel()
	$NbPivot = $oExcel.Worksheets($SheetsNb).PivotTables.Count
	ConsoleWrite("TDC " & $NbPivot & @CRLF)
	If $NbPivot = 0 Then ErreurExcel()
	$oExcel.Worksheets($SheetsNb).Select
	$oExcel.Worksheets($SheetsNb).PivotTables($PivotTable).Update
	Sleep(500)
	$oExcel.Worksheets($SheetsNb).PivotTables($PivotTable).PivotSelect("")
	$oExcel.Selection.CopyPicture(2,-4147);copie la table comme impression
	$oExcel.Worksheets($SheetsNb).Paste;converti en image
	$oExcel.Application.CutCopyMode = False
	$nbP = $oExcel.Worksheets($SheetsNb).Pictures.Count
	$oExcel.Worksheets($SheetsNb).Pictures($nbP).Copy;mise en mmoire
	$imageV = _ClipboardToStringImage()
	$image = Binary($imageV)
	$oExcel.Saved = True;pas de sauvegarde
	$oExcel.Quit()
	_LoadResBinary($sImgAlias, $image)
EndFunc   ;==>_LoadPicPivotTablesExcel
; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadPicTableExcel
; Description ...: Load a image in the pdf from table excel
; Syntax ........: _LoadPicTableExcel($sImgAlias, $sFilePath,$SheetsNb,$TableRange )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sFilePath              -  chemin du classeur excel.
;                  $SheetsNb              -  N sheets (par ordre de cration e.g. 2 )
;                  $TableRange              -  Range() (e.g. "A1:D11")
; Return values .: no
; Author(s) .....: Walkson
; Modified ......:
; Remarks .......:
; Related .......: _LoadResBinary  _ClipboardToStringImage()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _LoadPicTableExcel($sImgAlias, $sFilePath, $SheetsNb, $TableRange)
	If Not FileExists($sFilePath) Then Exit
	If ProcessExists("EXCEL.exe") Then Sleep(1000)
	If ProcessExists("EXCEL.exe") Then MsgBox(48, "MISE EN GARDE", "Fermez toutes les applications Excel")
	$oExcel = ObjCreate("Excel.Application")
	If @error Then ErreurExcel()
	$oExcel.Visible = False ; invisible
	$oExcel.ScreenUpdating = True
	$oExcel.DisplayAlerts = False
	_Excel_BookOpenA($oExcel, $sFilePath, True, Default, Default, Default);lecture seule
	$NbS = $oExcel.Sheets.Count
	If $SheetsNb > $NbS Then ErreurExcel()
	$oExcel.Sheets($SheetsNb).Range($TableRange).Copy;copi la table
	$oExcel.Sheets($SheetsNb).Pictures.Paste.Select;converti en image
	$oExcel.Application.CutCopyMode = False
	$nbP = $oExcel.Sheets($SheetsNb).Pictures.Count
	$oExcel.Sheets($SheetsNb).Pictures($nbP).Copy;mise en mmoire
	$imageV = _ClipboardToStringImage()
	$image = Binary($imageV)
	$oExcel.Saved = True;pas de sauvegarde
	$oExcel.Quit()
	_LoadResBinary($sImgAlias, $image)
EndFunc   ;==>_LoadPicTableExcel

; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadResBinary
; Description ...: Load a image in the pdf from memory
; Syntax ........: _LoadResImage( $sImgAlias , $sImage  )
; Parameters ....: $sImgAlias           -  an alias to identify the image in the pdf (e.g. "Cheese").
;                  $sImage              -  image From Memory.
; Return values .: Success      - True
;                  Failure      - False
; Author(s) .....: Mihai Iancu (taietel at yahoo dot com)
; Modified ......: Walkson
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/118827-create-pdf-from-your-application/
; Example .......: No
; ===============================================================================================================================
Func _LoadResBinary($sImgAlias, $sImage)
	Local $iW, $iH, $ImgBuf, $hImage, $hImageExt, $newImg, $hClone, $hGraphics, $iObj
	If $sImgAlias = "" Then __Error("You don't have an alias for the image", @ScriptLineNumber)
	If $sImage = "" Then
		__Error("You don't have any images to insert or the path is invalid", @ScriptLineNumber)
	Else
		_GDIPlus_Startup()
		$hImage = _GDIPlus_BitmapCreateFromMemory($sImage)
		$bitmap = _Bitmap2BinaryString($hImage, 90);mise au format jpg
		$iW = _GDIPlus_ImageGetWidth($hImage)
		$iH = _GDIPlus_ImageGetHeight($hImage)
		_GDIPlus_ImageSaveToFile($hImage, $newImg)
		$ImgBuf = BinaryToString($bitmap);mise en mmoire du jpg
		$_iImageW = $iW
		$_iImageH = $iH
		$iObj = __InitObj()
		__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
		__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
		__EndObj()
		$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
		__InitObj()
		__ToBuffer(StringLen($ImgBuf))
		__EndObj()
		_GDIPlus_ImageDispose($hImage)
		_GDIPlus_Shutdown()

	EndIf
	Return $_Image
EndFunc   ;==>_LoadResBinary

; Author ........: SEO <locodarwin at yahoo dot com>
; Modified.......: litlmike, water, GMK
Func _Excel_BookOpenA($oExcel, $sFilePath, $bReadOnly = Default, $bVisible = Default, $sPassword = Default, $sWritePassword = Default)
	If Not IsObj($oExcel) Or ObjName($oExcel, 1) <> "_Application" Then Return SetError(1, @error, 0)
	If Not FileExists($sFilePath) Then Return SetError(2, 0, 0)
	If $bReadOnly = Default Then $bReadOnly = False
	If $bVisible = Default Then $bVisible = True
	Local $oWorkbook = $oExcel.Workbooks.Open($sFilePath, Default, $bReadOnly, Default, $sPassword, $sWritePassword)
	If @error Then Return SetError(3, @error, 0)
	$oExcel.Windows($oWorkbook.Name).Visible = $bVisible
	; If a read-write workbook was opened read-only then return an error
	If $bReadOnly = False And $oWorkbook.Readonly = True Then Return SetError(4, 0, $oWorkbook)
	Return $oWorkbook
EndFunc   ;==>_Excel_BookOpenA
Func ErreurExcel()
	ConsoleWrite("Erreur" & @CRLF)
	If ProcessExists("EXCEL.exe") Then ProcessClose("EXCEL.exe")
	Exit
EndFunc   ;==>ErreurExcel
