#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include "MPDF_UDF_FR.au3"
#include <WinAPIGdi.au3>
;Aero peek Win7 requis. Ne fonctionne pas avec VirtualBox
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt, Word")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 100)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_ARIAL", $PDF_FONT_STD_ARIAL)
_LoadResZWEB("azerty1", "http://www.meteofrance.com/previsions-meteo-france/rhone-alpes/regi82", 39, 550, 670, 555)
_LoadResZWEB("azerty0", "http://www.meteofrance.com/previsions-meteo-france/bretagne/regi53", 39, 550, 670, 555)
_BeginPage()
_InsertRenderedText(5, 28, ">> Image WEB <<", "_ARIAL", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(1, 27, "Votre mto dans la rgion Rhne Alpes", "_ARIAL", 12, $PDF_ALIGN_LEFT)
_InsertImage("azerty1", 1, 26, 12)
_InsertImage("azerty0", 1, 15, 12)
_EndPage()
_ClosePDFFile()


; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadResZWEB
; Description ...: Capture une partie d'un site web
; Syntax ........: _LoadResZWEB($sImgAlias, $url, $iX, $iY, $iW, $iH)
; Parameters ....: $sImgAlias           - A string value.
;                  $url                 - URL value.
;                  $iX                  - The X coordinate of the upper left corner of the source image
;                  $iY                  - The Y coordinate of the upper left corner of the source image
;                  $iW                  - Width of the source image
;                  $iH                  - Height of the source image
; Return values .: None
; Author ........: Mihai Iancu (taietel at yahoo dot com), UEZ
; Modified ......: Walkson
; Remarks .......: Valeurs en pixel
; Related .......:
; Link ..........:
; ===============================================================================================================================
Func _LoadResZWEB($sImgAlias, $url, $iX, $iY, $iW, $iH)
	Local $__iVer = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion", "CurrentVersion")
	If $__iVer < 6.1 Then Exit MsgBox(0, "Erreur", "Votre Windows n'est pas Win7 ou plus")
	Local $oIE, $GUIActiveX, $oDocument, $oBody, $BodyWidth, $BodyHeight, $oHtml
	Local $hGUI_WebGrab, $hWin, $aWin, $aMP
	Local Const $BrowserNavConstant = 2 + 128 + 256 + 512 + 4096 + 32768 ;BrowserNavConstant -> http://msdn.microsoft.com/en-us/library/dd565688(v=vs.85).aspx

	$oIE = ObjCreate("Shell.Explorer.2") ;http://msdn.microsoft.com/en-us/library/aa752084(v=vs.85).aspx
	If @error Then Exit MsgBox(0, "Erreur", "Problme Shell.Explorer.2")
	$hWin = WinGetHandle("Program Manager")
	$aWin = WinGetPos(HWnd($hWin))
	$IEwidth = 1045
	$hGUI_WebGrab = GUICreate("", 0, 0, $aWin[0] - $BodyWidth + 1, $aWin[1] - $BodyHeight + 1, BitOR($WS_CLIPSIBLINGS, $WS_CLIPCHILDREN, $WS_POPUP), $WS_EX_TOOLWINDOW, WinGetHandle(AutoItWinGetTitle()))
	$GUIActiveX = GUICtrlCreateObj($oIE, 0, 0, $IEwidth, 256)
	GUISetState(@SW_MINIMIZE, $hGUI_WebGrab)
	Local $timeout = 60 * 1000
	Local $timer = TimerInit()
	ToolTip("Chargement du site " & $url, 100, 100,"Connection Web")
	With $oIE
		.silent = True
		.FullScreen = True
		.Resizable = False
		.Visible = False
		.StatusBar = False
		.AddressBar = False
		.Navigate($url, $BrowserNavConstant, "_top")
		Do
			If TimerDiff($timer) > $timeout Then ExitLoop
			Sleep(500)
		Until .ReadyState = 4
		.Stop
	EndWith
	Sleep(500)

	$oDocument = $oIE.document
	$oBody = $oDocument.body
	$oBody.scroll = "no"
	$oBody.Style.borderStyle = "none"
	$BodyWidth = $oBody.scrollWidth
	$BodyHeight = $oBody.scrollHeight
	GUIDelete($hGUI_WebGrab)
	$GUIActiveX = 0

	$oIE = 0
	$oIE = ObjCreate("Shell.Explorer.2")
	Local $IE_Ver = RegRead("HKLM\SOFTWARE\Microsoft\Internet Explorer", "Version"), $height, $8192Limit = False
	If $BodyHeight > 8190 And $IE_Ver = 9 Then
		$BodyHeight = 8190
		$8192Limit = True
	EndIf

	$hGUI_WebGrab = GUICreate("", $BodyWidth, $BodyHeight, $aWin[0] - $BodyWidth + 1, $aWin[1] - $BodyHeight + 1, BitOR($WS_CLIPSIBLINGS, $WS_CLIPCHILDREN, $WS_POPUP), $WS_EX_TOOLWINDOW, WinGetHandle(AutoItWinGetTitle()))
	$GUIActiveX = GUICtrlCreateObj($oIE, 0, 0, $BodyWidth, $BodyHeight) ;with IE9 max. height can be only 8192 otherwise white screen only!?!?

	$timer = TimerInit()
	With $oIE
		.silent = True
		.FullScreen = True
		.Resizable = False
		.Visible = False
		.StatusBar = False
		.AddressBar = False
		.Navigate($url, $BrowserNavConstant, "_top")
		Do
			If TimerDiff($timer) > $timeout Then ExitLoop
			Sleep(500)
		Until .ReadyState = 4
		.Stop
		Sleep(1000)
	EndWith
	ToolTip("")
	$oDocument = $oIE.document
	$oBody = $oDocument.body
	$oHtml = $oDocument.documentElement
	$oBody.scroll = "no"
	$oBody.Style.borderStyle = "none"
	$oBody.Style.border = "0px"
	$oHtml.Style.overflow = 'hidden'
	$aMP = MouseGetPos()
	GUISetState(@SW_SHOWNA, $hGUI_WebGrab) ;Show GUI for some milli seconds to make a screenshot
	Sleep(500)
	MouseMove($aMP[0], $aMP[1], 0)
	$BodyWidth = $BodyWidth - 300
	$BodyHeight = $BodyHeight - 300
	Local $hDC_Web = _WinAPI_GetWindowDC($hGUI_WebGrab)
	Local $hDC_Dummy = _WinAPI_GetWindowDC(0)
	Local $hMemDC = _WinAPI_CreateCompatibleDC($hDC_Dummy)
	Local $hBitmap = _WinAPI_CreateCompatibleBitmap($hDC_Dummy, $BodyWidth, $BodyHeight)
	Local $hObjectOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
	_WinAPI_BitBlt($hMemDC, 0, 0, $BodyWidth, $BodyHeight, $hDC_Web, 0, 0, $SRCCOPY)
	_GDIPlus_Startup()
	$hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	_WinAPI_DeleteObject($hBitmap) ;if activated clipboard is not working anymore because bitmap is deleted from mem
	_WinAPI_SelectObject($hMemDC, $hObjectOld)
	_WinAPI_DeleteDC($hMemDC)
	_WinAPI_ReleaseDC($hGUI_WebGrab, $hDC_Web)
	_WinAPI_ReleaseDC(0, $hDC_Dummy)
	_WinAPI_ReleaseDC(0, $hDC_Web)
	GUIDelete($hGUI_WebGrab)
	;$sPath = @DesktopDir & "\winapibitmapA.bmp"
	;_GDIPlus_ImageSaveToFile($hImage, $sPath)
	$newImg = _TempFile(@ScriptDir, "~", ".jpg")

	$hImageblc = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($hImageblc)
	_GDIPlus_GraphicsClear($hGraphics, 0xFFFFFFFF)
	_GDIPlus_GraphicsDrawImageRectRect($hGraphics, $hImage, $iX, $iY, $iW, $iH, 0, 0, $iW, $iH)
	$urlC = StringRegExpReplace($url, "(.*?//)(.*?)(/..*)", "$2")
	_GDIPlus_GraphicsDrawString($hGraphics, $urlC, 5, $iH - 10, "Arial", 8)
	_GDIPlus_GraphicsDrawString($hGraphics, " UEZ Windows Screenshooter", $iW - 12, $iH - 150, "Arial", 7, BitOR(0x0002, 0x2000))

	_GDIPlus_ImageSaveToFile($hImageblc, $newImg)


	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()


	$ImgBuf = __ToBinary($newImg)
	$_iImageW = $iW
	$_iImageH = $iH
	$iObj = __InitObj()
	__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
	__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
	__EndObj()
	$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
	__InitObj()
	__ToBuffer(StringLen($ImgBuf))
	__EndObj()
	FileDelete($newImg)

EndFunc   ;==>_LoadResZWEB
