#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include "..\MPDF_UDF_FR.au3"
#RequireAdmin ;droit requis pour l'installation OcvitaBarcode.ocx
;Verification CB http://www.onlinebarcodereader.com/en.html ou http://zxing.org/w/decode.jspx
;Concept http://sourceforge.net/projects/zint/
;http://www.ocvita.ru/content/view/90/35/ pour le tlchargement OcvitaBarcode.ocx
;https://www.virustotal.com/fr/file/b7774d87ca773081d0fc7e61639207576be9b74b5c3f1916fb0dd5c0c96581a9/analysis/1423587937/
;Le script installe et dsinstalle l'Ocx. Pour l'viter, dsactiver la ligne 128
;Certains CB n'acceptent pas des lettres, d'autres ont un nombre de chiffres limits. Ce script ne prvient pas des erreurs
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 90)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontTT("_Arial", $PDF_FONT_ARIAL, $PDF_FONT_BOLD)
 _OcvitaBc("BCazerty", @ScriptDir & "\OcvitaBarcode.ocx", 20, "bonjour", 400, 200, "1EF7CF", "B22400", 2)
 _OcvitaBc("BCazerty_1", @ScriptDir & "\OcvitaBarcode.ocx", 58, "bonjour", 200, 200, "", "", 2)
  _OcvitaBc("BCazerty_2", @ScriptDir & "\OcvitaBarcode.ocx", 8, "BARCODE 39", "", "", "", "", 1)


_BeginPage()
_DrawText(3, 28, "Insertion d'un codebarre", "_Arial", 24, $PDF_ALIGN_LEFT)
_InsertImage("BCazerty", 2, 20, 5, 2)
_InsertImage("BCazerty_1", 2, 15, 3,3)
_InsertImage("BCazerty_2", 10, 15, 6, 3)
_EndPage()
_ClosePDFFile()


; #FUNCTION# ====================================================================================================================
; Name ..........: _OcvitaBc
; Description ...: Cration d'une image codebarre avec OcvitaBarcode.ocx
; Syntax ........: _OcvitaBc($sImgAlias, $ActiveX, $ChoixCB, $hValue[, $iwidth = 600[, $iheight = 200[, $colorFond = "FFFFFF"[,
;                  $colorBar = "000000"[, $optionOCX = 1]]]]])
; Parameters ....:  $sImgAlias			- alias
;					$ActiveX             - Chemin de OcvitaBarcode.ocx.
;                  $ChoixCB             - N du codebarre. e.g. BARCODE_CODE128 = 20 (dtails sous la fonction)
;                  $hValue              - Valeur du codebarre.
;                  $iwidth              - [optional] largeur. Default is 600.
;                  $iheight             - [optional] hauteur. Default is 200.
;                  $colorFond           - [optional] couleur du fond. Default is "FFFFFF".
;                  $colorBar            - [optional] couleur du codebarre. Default is "000000".
;                  $optionOCX           - [optional] dsinstallation ocx: 2 garde ocx, 1 dsinstalle ocx. Default is 1.
; Return values .: None
; Author ........: Walkson
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.ocvita.ru/content/view/90/35/
; Example .......: No
; ===============================================================================================================================
Func _OcvitaBc($sImgAlias, $ActiveX, $ChoixCB, $hValue, $iwidth = 600, $iheight = 200, $colorFond = "FFFFFF", $colorBar = "000000", $optionOCX = 1)
	Local $hGUI, $oBCode
	Global $iW, $iH
	If $iwidth = "" Then $iwidth = 600
	If $iheight = "" Then $iheight = 200
	If $colorFond = "" Then $colorFond = "FFFFFF"
	If $colorBar = "" Then $colorBar = "000000"
	If $optionOCX = "" Then $optionOCX = 1
	$oBCode = ObjCreate("Ocvita.Barcode")
	If Not IsObj($oBCode) Then ;installe OcvitaBarcode.ocx
		RunWait(@ComSpec & " /c " & 'Regsvr32 /s /i "' & $ActiveX & '"', "", @SW_HIDE)
		$oBCode = ObjCreate("Ocvita.Barcode")
		If @error Then Return SetError(1,0,1)
	EndIf
	; Create GUI
	$iW = $iwidth
	$iH = $iheight
	$hGUI = GUICreate("AAA", $iW, $iH, 0, 0, BitOR($WS_CLIPSIBLINGS, $WS_CLIPCHILDREN, $WS_POPUP), $WS_EX_TOOLWINDOW, WinGetHandle(AutoItWinGetTitle()))
	$input1 = GUICtrlCreateObj($oBCode, 0, 0, $iW, $iH)
	GUISetState(@SW_HIDE, $hGUI)
	$oBCode.symbology = $ChoixCB ;71;60;58
	;$oBCode.height = 90
	; $oBCode.width = 100
	$oBCode.fgcolour = $colorBar ;"B22400"
	$oBCode.bgcolour = $colorFond ;"1EF7CF";"99eaea"
	$oBCode.barcode = $hValue ;"bonjour"
	;$oBCode.scale = 0.8


	Sleep(500)

	$wnd = GUICtrlGetHandle($input1)
_GDIPlus_Startup()
GUISetState(@SW_SHOW, $hGUI)
$hDDC = _WinAPI_GetWindowDC($wnd)
$hCDC = _WinAPI_CreateCompatibleDC($hDDC)
$hHBMP = _WinAPI_CreateCompatibleBitmap($hDDC, $iWidth, $iHeight)
_WinAPI_SelectObject($hCDC, $hHBMP)
_WinAPI_BitBlt($hCDC, 0, 0, $iWidth, $iHeight, $hDDC, 0, 0, $SRCCOPY)
GUIDelete($hGUI)
$hBitmap = _GDIPlus_BitmapCreateFromHBITMAP($hHBMP)
$bitmap = _Bitmap2BinaryString($hBitmap, 90);mise au format jpg
;FileWrite(@DesktopDir & "\AAA.jpg", BinaryToString($bitmap))
				$iW = _GDIPlus_ImageGetWidth($hBitmap)
				$iH = _GDIPlus_ImageGetHeight($hBitmap)

				ConsoleWrite($iW & " >> " & $iH & @CRLF)
				ConsoleWrite( _GetUnit() & @CRLF)

				$ImgBuf = BinaryToString($bitmap);mise en mmoire du jpg
				$_iImageW = $iW
				$_iImageH = $iH
				$iObj = __InitObj()
				__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
				__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
				__EndObj()
				$_Image &= "/" & $sImgAlias & " " & $iObj & " 0 R " & @CRLF
				__InitObj()
				__ToBuffer(StringLen($ImgBuf))
				__EndObj()
$bitmap = 0
_WinAPI_DeleteDC($hCDC)
_WinAPI_ReleaseDC($wnd, $hDDC)
_GDIPlus_BitmapDispose($hBitmap)
_WinAPI_DeleteObject($hHBMP)
    _GDIPlus_Shutdown()

	$oBCode = 0
	If $optionOCX = 1 Then ;dsinstalle ocx
		RunWait(@ComSpec & " /c " & 'Regsvr32 /s /u "' & $ActiveX & '"', "", @SW_HIDE)
		;RunWait(@ComSpec & " /c " & 'Regsvr32  /u "' & $ActiveX & '"', "", @SW_SHOW)
		$oBCode = 0
	EndIf
	Return @ScriptDir & "\OcvitaBarCode.jpg"
EndFunc   ;==>_OcvitaBc

#cs
	1 BARCODE_CODE11 Code 11
	2 BARCODE_C25MATRIX Standard Code 2 of 5
	3 BARCODE_C25INTER Interleaved 2 of 5
	4 BARCODE_C25IATA Code 2 of 5 IATA
	6 BARCODE_C25LOGIC Code 2 of 5 Data Logic
	7 BARCODE_C25IND Code 2 of 5 Industrial
	8 BARCODE_CODE39 Code 3 of 9 (Code 39)
	9 BARCODE_EXCODE39 Extended Code 3 of 9 (Code 39+)
	13 BARCODE_EANX EAN
	16 BARCODE_EAN128 GS1-128
	18 BARCODE_CODABAR Codabar
	20 BARCODE_CODE128 Code 128 (automatic subset switching)
	21 BARCODE_DPLEIT Deutshe Post Leitcode
	22 BARCODE_DPIDENT Deutshe Post Identcode
	23 BARCODE_CODE16K Code 16K
	24 BARCODE_CODE49 Code 49
	25 BARCODE_CODE93 Code 93
	28 BARCODE_FLAT Flattermarken
	29 BARCODE_RSS14 GS1 DataBar-14
	30 BARCODE_RSS_LTD GS1 DataBar Limited
	31 BARCODE_RSS_EXP GS1 DataBar Expanded 21/61
	32 BARCODE_TELEPEN Telepen Alpha
	34 BARCODE_UPCA UPC A
	37 BARCODE_UPCE UPC E
	40 BARCODE_POSTNET PostNet
	47 BARCODE_MSI_PLESSEY MSI Plessey
	49 BARCODE_FIM FIM
	50 BARCODE_LOGMARS LOGMARS
	51 BARCODE_PHARMA Pharmacode One-Track
	52 BARCODE_PZN PZN
	53 BARCODE_PHARMA_TWO Pharmacode Two-Track
	55 BARCODE_PDF417 PDF417
	56 BARCODE_PDF417TRUNC PDF417 Truncated
	57 BARCODE_MAXICODE Maxicode
	58 BARCODE_QRCODE QR Code
	60 BARCODE_CODE128B Code 128 (Subset B)
	63 BARCODE_AUSPOST Australia Post Standard Customer
	66 BARCODE_AUSREPLY Australia Post Reply Paid
	67 BARCODE_AUSROUTE Australia Post Routing
	68 BARCODE_AUSREDIRECT Australia Post Redirection
	69 BARCODE_ISBNX ISBN (EAN-13 with verification stage)
	70 BARCODE_RM4SCC Royal Mail 4 State (RM4SCC)
	71 BARCODE_DATAMATRIX Data Matrix
	72 BARCODE_EAN14 EAN-14
	75 BARCODE_NVE18 NVE-18
	76 BARCODE_JAPANPOST Japanese Post
	77 BARCODE_KOREAPOST Korea Post
	79 BARCODE_RSS14STACK GS1 DataBar-14 Stacked
	80 BARCODE_RSS14STACK_OMNI GS1 DataBar-14 Stacked Omnidirectional
	81 BARCODE_RSS_EXPSTACK GS1 DataBar Expanded Stacked 22/61
	82 BARCODE_PLANET PLANET
	84 BARCODE_MICROPDF417 MicroPDF417
	85 BARCODE_ONECODE USPS OneCode
	86 BARCODE_PLESSEY Plessey Code
	87 BARCODE_TELEPEN_NUM Telepen Numeric
	89 BARCODE_ITF14 ITF-14
	90 BARCODE_KIX Dutch Post KIX Code
	92 BARCODE_AZTEC Aztec Code
	93 BARCODE_DAFT DAFT Code
	97 BARCODE_MICROQR Micro QR Code
	98 BARCODE_HIBC_128 HIBC Code 128
	99 BARCODE_HIBC_39 HIBC Code 39
	102 BARCODE_HIBC_DM HIBC Data Matrix
	104 BARCODE_HIBC_QR HIBC QR Code
	106 BARCODE_HIBC_PDF HIBC PDF417
	108 BARCODE_HIBC_MICPDF HIBC MicroPDF417
	112 BARCODE_HIBC_AZTEC HIBC Aztec Code
	128 BARCODE_AZRUNE Aztec Runes
	129 BARCODE_CODE32 Code 32
	130 BARCODE_EANX_CC Composite Symbol with EAN linear component
	131 BARCODE_EAN128_CC Composite Symbol with GS1-128 linear component
	132 BARCODE_RSS14_CC Composite Symbol with GS1 DataBar-14 linear component
	133 BARCODE_RSS_LTD_CC Composite Symbol with GS1 DataBar Limited component
	134 BARCODE_RSS_EXP_CC Composite Symbol with GS1 DataBar Extended component
	135 BARCODE_UPCA_CC Composite Symbol with UPC A linear component 23/61
	136 BARCODE_UPCE_CC Composite Symbol with UPC E linear component
	137 BARCODE_RSS14STACK_CC Composite Symbol with GS1 DataBar-14 Stacked component
	138 BARCODE_RSS14_OMNI_CC Composite Symbol with GS1 DataBar-14 Stacked Omnidirectional component
	139 BARCODE_RSS_EXPSTACK_CC Composite Symbol with GS1 DataBar Expanded Stacked component
	140 BARCODE_CHANNEL Channel Code
	141 BARCODE_CODEONE Code One
	142 BARCODE_GRIDMATRIX Grid Matrix
#ce
