#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include "MPDF_UDF_FR.au3"
#include <WinAPIGdi.au3>
;Aero peek Win7 requis. Ne fonctionne pas avec VirtualBox
_SetTitle("Demo PDF in AutoIt")
_SetSubject("Demo PDF in AutoIt, without any ActiveX or DLL...")
_SetKeywords("pdf, demo, AutoIt, Word")
_OpenAfter(True)
_SetUnit($PDF_UNIT_CM)
_SetPaperSize("A4")
_SetZoomMode($PDF_ZOOM_CUSTOM, 75)
_SetOrientation($PDF_ORIENTATION_PORTRAIT)
_SetLayoutMode($PDF_LAYOUT_CONTINOUS)
_InitPDF(@ScriptDir & "\test.pdf")
_LoadFontStandard("_Helv", $PDF_FONT_STD_HELVETICA)
_LoadFontStandard("_Cour", $PDF_FONT_STD_COURIER)

$nbpages = _LoadResWEB("image", "http://www.autoitscript.fr/forum/viewforum.php?f=3")
$nbpages1 = _LoadResWEB("image1", "http://fr.wikipedia.org/wiki/Sngal")
$nbpages2 = _LoadResWEB("image2", "https://news.google.fr/")
_BeginPage()
_InsertRenderedText(5, 28, ">> Site WEB en PDF <<", "_Helv", 32, 100, $PDF_ALIGN_CENTER, 0xFFFF00, 0xFF6600)
_DrawText(5, 20, "Web  la page", "_Cour", 42, $PDF_ALIGN_LEFT)
_EndPage()
_InsertPageWeb("image", $nbpages)
_InsertPageWeb("image1", $nbpages1)
_InsertPageWeb("image2", $nbpages2)
_ClosePDFFile()

; #FUNCTION# ====================================================================================================================
; Name ..........: _InsertPageWeb
; Description ...: Import images Web Dans PDF
; Syntax ........: _InsertPageWeb($sImgAlias, $nbImages)
; Parameters ....: $sImgAlias           - Alias de _LoadResWEB().
;                  $nbImages            - Retour de valeur de _LoadResWEB() pour le nombre de pages.
; Return values .: None
; ===============================================================================================================================
Func _InsertPageWeb($sImgAlias, $nbImages)
	For $y = 0 To $nbImages - 1
		_BeginPage()
		_InsertImage($sImgAlias & $y, 0, 0, 21, 29.7)
		_EndPage()
	Next

EndFunc   ;==>_InsertPageWeb

; #FUNCTION# ====================================================================================================================
; Name ..........: _LoadResWEB
; Description ...: Charge une page Web pour import PDF
; Syntax ........: _LoadResWEB($sImgAlias, $url)
; Parameters ....: $sImgAlias           - Alias.
;                  $url                 - Url du site.
; Return values .: $nbImages (nombre de pages)
; Author ........: UEZ, taietel
; Modified ......: Walkson
; Remarks .......:  UEZ Windows Screenshooter
; Related .......: _InsertPageWeb()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _LoadResWEB($sImgAlias, $url)
    Local $__iVer = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion", "CurrentVersion")
    If $__iVer < 6.1 Then Exit MsgBox(0,"Erreur","Votre Windows n'est pas Win7 ou plus")
	Local $oIE, $GUIActiveX, $oDocument, $oBody, $BodyWidth, $BodyHeight, $oHtml
	Local $hGUI_WebGrab, $hWin, $aWin, $aMP
	Local Const $BrowserNavConstant = 2 + 128 + 256 + 512 + 4096 + 32768 ;BrowserNavConstant -> http://msdn.microsoft.com/en-us/library/dd565688(v=vs.85).aspx
	$oIE = ObjCreate("Shell.Explorer.2") ;http://msdn.microsoft.com/en-us/library/aa752084(v=vs.85).aspx
	If @error Then Exit MsgBox(0,"Erreur","Problme Shell.Explorer.2")
	$hWin = WinGetHandle("Program Manager")
	$aWin = WinGetPos(HWnd($hWin))
	$IEwidth = 1045
	$hGUI_WebGrab = GUICreate("", 0, 0, $aWin[0] - $BodyWidth + 1, $aWin[1] - $BodyHeight + 1, BitOR($WS_CLIPSIBLINGS, $WS_CLIPCHILDREN, $WS_POPUP), $WS_EX_TOOLWINDOW, WinGetHandle(AutoItWinGetTitle()))
	$GUIActiveX = GUICtrlCreateObj($oIE, 0, 0, $IEwidth, 256)
	GUISetState(@SW_MINIMIZE, $hGUI_WebGrab)
	Local $timeout = 60 * 1000
	Local $timer = TimerInit()
	ToolTip("Chargement du site " & $url, 100, 100,"Connection Web")
	With $oIE
		.silent = True
		.FullScreen = True
		.Resizable = False
		.Visible = False
		.StatusBar = False
		.AddressBar = False
		.Navigate($url, $BrowserNavConstant, "_top")
		Do
			If TimerDiff($timer) > $timeout Then ExitLoop
			Sleep(500)
		Until .ReadyState = 4
		.Stop
	EndWith
	Sleep(500)

	$oDocument = $oIE.document
	$oBody = $oDocument.body
	$oBody.scroll = "no"
	$oBody.Style.borderStyle = "none"
	$BodyWidth = $oBody.scrollWidth
	$BodyHeight = $oBody.scrollHeight
	GUIDelete($hGUI_WebGrab)
	$GUIActiveX = 0

	$oIE = 0
	$oIE = ObjCreate("Shell.Explorer.2")
	Local $IE_Ver = RegRead("HKLM\SOFTWARE\Microsoft\Internet Explorer", "Version"), $height, $8192Limit = False
	If $BodyHeight > 8190 And $IE_Ver = 9 Then
		$BodyHeight = 8190
		$8192Limit = True
	EndIf

	$hGUI_WebGrab = GUICreate("", $BodyWidth, $BodyHeight, $aWin[0] - $BodyWidth + 1, $aWin[1] - $BodyHeight + 1, BitOR($WS_CLIPSIBLINGS, $WS_CLIPCHILDREN, $WS_POPUP), $WS_EX_TOOLWINDOW, WinGetHandle(AutoItWinGetTitle()))
	$GUIActiveX = GUICtrlCreateObj($oIE, 0, 0, $BodyWidth, $BodyHeight) ;with IE9 max. height can be only 8192 otherwise white screen only!?!?

	$timer = TimerInit()

	With $oIE
		.silent = True
		.FullScreen = True
		.Resizable = False
		.Visible = False
		.StatusBar = False
		.AddressBar = False
		.Navigate($url, $BrowserNavConstant, "_top")
		Do
			If TimerDiff($timer) > $timeout Then ExitLoop
			Sleep(500)
		Until .ReadyState = 4
		.Stop
		Sleep(1000)
	EndWith
	ToolTip("")
	$oDocument = $oIE.document
	$oBody = $oDocument.body
	$oHtml = $oDocument.documentElement
	$oBody.scroll = "no"
	$oBody.Style.borderStyle = "none"
	$oBody.Style.border = "0px"
	$oHtml.Style.overflow = 'hidden'
	$aMP = MouseGetPos()
	GUISetState(@SW_SHOWNA, $hGUI_WebGrab) ;Show GUI for some milli seconds to make a screenshot
	Sleep(500)
	MouseMove($aMP[0], $aMP[1], 0)
	Local $hDC_Web = _WinAPI_GetWindowDC($hGUI_WebGrab)
	Local $hMemDC = _WinAPI_CreateCompatibleDC($hDC_Web)
	Local $hBitmap = _WinAPI_CreateCompatibleBitmap($hDC_Web, $BodyWidth, $BodyHeight)
	Local $hObjectOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
	_WinAPI_BitBlt($hMemDC, 0, 0, $BodyWidth, $BodyHeight, $hDC_Web, 0, 0, $SRCCOPY)
	_GDIPlus_Startup()
	$hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	ConsoleWrite($BodyWidth & " >> " & $BodyHeight & @CR)
	_WinAPI_DeleteObject($hBitmap) ;if activated clipboard is not working anymore because bitmap is deleted from mem
	_WinAPI_SelectObject($hMemDC, $hObjectOld)
	_WinAPI_DeleteDC($hMemDC)
	_WinAPI_ReleaseDC($hGUI_WebGrab, $hDC_Web)
	_WinAPI_ReleaseDC(0, $hDC_Web)
	GUIDelete($hGUI_WebGrab)

	$iW = $BodyWidth
	$iH = $BodyHeight
	$pH = $iW / 0.707
	$pH = Round($pH, 0)
	;si < 0.500 >> dformation calcul hauteur sur rapport 0.707 (A4)
	;divise hauteur origine par nb hauteur calcule A4 >> renvoie hauteur moyenne (vite mini page)
	If $iW / $iH < 0.500 Then $iH = $iH / Round($iH / $pH, 0)
	$iH = Round($iH, 2)
	$nbImages = Round($BodyHeight / $iH, 0)
	If $nbImages > 0 Then
		$hImageblc = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
		$hGraphics = _GDIPlus_ImageGetGraphicsContext($hImageblc)
		_GDIPlus_GraphicsClear($hGraphics, 0xFFFFFFFF)
		ConsoleWrite($iW & " >>> " & $iH & " >>> " & $nbImages & @CR)
		If FileExists(@ScriptDir & "\hIMAGESWeb") Then
			MsgBox(0, "Erreur", "Le dossier " & @ScriptDir & "\hIMAGESWeb" & " existe" & @CRLF _
					 & "renommez ce dossier. Fin du programme")
			Exit
		Else
			DirCreate(@ScriptDir & "\hIMAGESWeb") ;dossier dtruit  la fin
		EndIf


		For $i = 0 To $nbImages - 1
			$top = $iH * $i
			;Superposition de 10 pour viter les lignes coupes illisibles
			_GDIPlus_GraphicsDrawImageRectRect($hGraphics, $hImage, 0, $top - 10, $iW, $iH + 10, 0, 0, $iW, $iH)
			$urlC = StringRegExpReplace($url, "(.*?//)(.*?)(/..*)", "$2")
			_GDIPlus_GraphicsDrawString($hGraphics, $urlC, 5, $iH - 20, "Arial", 8)
			_GDIPlus_GraphicsDrawString($hGraphics, " UEZ Windows Screenshooter", $iW - 12, $iH - 150, "Arial", 7, BitOR(0x0002, 0x2000))
			$newImg = @ScriptDir & "\hIMAGESWeb\images" & $i & ".jpg"
			_GDIPlus_ImageSaveToFile($hImageblc, $newImg)

			$ImgBuf = __ToBinary($newImg)
			$_iImageW = $iW
			$_iImageH = $iH
			$iObj = __InitObj()
			__ToBuffer("<</Type /XObject /Subtype /Image /Name /" & $sImgAlias & $i & " /Width " & $_iImageW & " /Height " & $_iImageH & " /Filter /DCTDecode /ColorSpace /DeviceRGB /BitsPerComponent 8" & " /Length " & $iObj + 1 & " 0 R" & ">>")
			__ToBuffer("stream" & @CRLF & $ImgBuf & @CRLF & "endstream")
			__EndObj()
			$_Image &= "/" & $sImgAlias & $i & " " & $iObj & " 0 R " & @CRLF
			__InitObj()
			__ToBuffer(StringLen($ImgBuf))
			__EndObj()
		Next

		_GDIPlus_ImageDispose($hImage)
		_GDIPlus_GraphicsDispose($hGraphics)
		_GDIPlus_BitmapDispose($hImageblc)
		_GDIPlus_Shutdown()
		DirRemove(@ScriptDir & "\hIMAGESWeb", 1)
		Return $nbImages
	EndIf
EndFunc   ;==>_LoadResWEB
